import { __assign } from 'tslib';
import { Injectable, ComponentFactoryResolver, ɵɵdefineInjectable, ɵɵinject, Component, Input, Directive, ViewContainerRef, ViewChild, NgModule } from '@angular/core';
import { trigger, state, style, transition, animate } from '@angular/animations';
import { CommonModule } from '@angular/common';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/toast.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Toast = /** @class */ (function () {
    function Toast(component, data) {
        this.component = component;
        this.data = data;
    }
    return Toast;
}());
if (false) {
    /** @type {?} */
    Toast.prototype.component;
    /** @type {?} */
    Toast.prototype.data;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/bootstrap-toast.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BootstrapToastService = /** @class */ (function () {
    function BootstrapToastService(componentFactoryResolver) {
        this.componentFactoryResolver = componentFactoryResolver;
    }
    /**
     * @param {?} viewContainerRef
     * @param {?} component
     * @return {?}
     */
    BootstrapToastService.prototype.init = /**
     * @param {?} viewContainerRef
     * @param {?} component
     * @return {?}
     */
    function (viewContainerRef, component) {
        this.toasts = viewContainerRef;
        this.component = component;
    };
    /**
     * @param {?} message
     * @return {?}
     */
    BootstrapToastService.prototype.create = /**
     * @param {?} message
     * @return {?}
     */
    function (message) {
        /** @type {?} */
        var toast = new Toast(this.component, {
            title: null,
            body: message,
            createdAt: (new Date()).getTime(),
            autoClose: true
        });
        /** @type {?} */
        var componentFactory = this.componentFactoryResolver.resolveComponentFactory(toast.component);
        /** @type {?} */
        var componentRef = this.toasts.createComponent(componentFactory);
        (componentRef.instance).data = __assign({}, toast.data, { viewRef: componentRef.hostView });
    };
    /**
     * @param {?} toastItemRef
     * @return {?}
     */
    BootstrapToastService.prototype.remove = /**
     * @param {?} toastItemRef
     * @return {?}
     */
    function (toastItemRef) {
        this.toasts.remove(this.toasts.indexOf(toastItemRef));
    };
    BootstrapToastService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    BootstrapToastService.ctorParameters = function () { return [
        { type: ComponentFactoryResolver }
    ]; };
    /** @nocollapse */ BootstrapToastService.ngInjectableDef = ɵɵdefineInjectable({ factory: function BootstrapToastService_Factory() { return new BootstrapToastService(ɵɵinject(ComponentFactoryResolver)); }, token: BootstrapToastService, providedIn: "root" });
    return BootstrapToastService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    BootstrapToastService.prototype.toasts;
    /**
     * @type {?}
     * @private
     */
    BootstrapToastService.prototype.component;
    /**
     * @type {?}
     * @private
     */
    BootstrapToastService.prototype.componentFactoryResolver;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/notification/notification.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NotificationComponent = /** @class */ (function () {
    function NotificationComponent(toastService) {
        this.toastService = toastService;
        this.isClosed = false;
        this.elapsedMinutes = 0;
        this.progressBarStarted = false;
        this.seconds = 3.5;
    }
    /**
     * @return {?}
     */
    NotificationComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.data.autoClose) {
            this.interval = setInterval((/**
             * @return {?}
             */
            function () {
                _this.onClose();
            }), this.seconds * 1000);
        }
        else {
            this._setElapsedMinutes();
            this.interval = setInterval((/**
             * @return {?}
             */
            function () {
                _this._setElapsedMinutes();
            }), 1000);
        }
    };
    /**
     * @return {?}
     */
    NotificationComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        clearInterval(this.interval);
    };
    /**
     * @return {?}
     */
    NotificationComponent.prototype.onClose = /**
     * @return {?}
     */
    function () {
        this.isClosed = true;
    };
    /**
     * @return {?}
     */
    NotificationComponent.prototype.onRemove = /**
     * @return {?}
     */
    function () {
        if (this.isClosed) {
            this.toastService.remove(this.data.viewRef);
        }
    };
    /**
     * @return {?}
     */
    NotificationComponent.prototype.onStartProgressBar = /**
     * @return {?}
     */
    function () {
        this.progressBarStarted = true;
    };
    /**
     * @private
     * @return {?}
     */
    NotificationComponent.prototype._setElapsedMinutes = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var now = +new Date();
        /** @type {?} */
        var created = +new Date(this.data.createdAt);
        this.elapsedMinutes = (new Date(now - created)).getMinutes();
    };
    NotificationComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-notification',
                    template: "<div \n    class=\"toast\"\n    role=\"alert\"\n    aria-live=\"assertive\"\n    aria-atomic=\"true\"\n    [@close-toast]=\"!isClosed ? 'open' : 'close'\"\n    [@open-toast]=\"'open'\"\n    (@close-toast.done)=\"onRemove()\"\n    (@open-toast.done)=\"onStartProgressBar()\">\n    <div class=\"toast-header\">\n        <img *ngIf=\"data.icon\"  [src]=\"data.icon\" class=\"icon rounded mr-2\" alt=\"Toast icon\">\n        <strong class=\"mr-auto\">{{ data.title || 'Message' }}</strong>\n        <small \n            *ngIf=\"elapsedMinutes > 0\" \n            class=\"text-muted\">{{ elapsedMinutes }} mins ago</small>\n        <button \n            type=\"button\"\n            class=\"ml-2 mb-1 close\"\n            (click)=\"onClose()\" \n            data-dismiss=\"toast\"\n            aria-label=\"Close\">\n        <span aria-hidden=\"true\">&times;</span>\n        </button>\n    </div>\n    <div class=\"toast-body\">\n        {{ data.body }}\n    </div>\n    <div class=\"toast-progress-bar\" *ngIf=\"data.autoClose\" >\n        <div class=\"progress\">\n            <div class=\"progress-bar\" role=\"progressbar\" [@progress-bar]=\"progressBarStarted ? 'progress' : ''\" ></div>\n        </div>\n    </div>\n</div>",
                    animations: [
                        trigger('close-toast', [
                            state('close', style({ opacity: 0 })),
                            transition('* => close', [
                                animate('0.5s')
                            ])
                        ]),
                        trigger('open-toast', [
                            state('open', style({ right: 0 })),
                            transition('* => open', [
                                animate('0.5s ease-out')
                            ])
                        ]),
                        trigger('progress-bar', [
                            state('progress', style({ width: '100%' })),
                            transition('* => progress', [
                                animate('3s')
                            ])
                        ])
                    ],
                    styles: [".toast{position:relative;right:-350px;opacity:1;margin:25px;min-width:320px;max-width:320px}.toast .icon{width:18px;height:auto}.toast .progress{height:2px;border-radius:0!important;background-color:transparent}"]
                }] }
    ];
    /** @nocollapse */
    NotificationComponent.ctorParameters = function () { return [
        { type: BootstrapToastService }
    ]; };
    NotificationComponent.propDecorators = {
        data: [{ type: Input }]
    };
    return NotificationComponent;
}());
if (false) {
    /** @type {?} */
    NotificationComponent.prototype.data;
    /** @type {?} */
    NotificationComponent.prototype.isClosed;
    /** @type {?} */
    NotificationComponent.prototype.elapsedMinutes;
    /** @type {?} */
    NotificationComponent.prototype.progressBarStarted;
    /**
     * @type {?}
     * @private
     */
    NotificationComponent.prototype.interval;
    /**
     * @type {?}
     * @private
     */
    NotificationComponent.prototype.seconds;
    /**
     * @type {?}
     * @private
     */
    NotificationComponent.prototype.toastService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/toast.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ToastDirective = /** @class */ (function () {
    function ToastDirective(viewContainerRef) {
        this.viewContainerRef = viewContainerRef;
    }
    ToastDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[lib-bootstrap-toast-host]'
                },] }
    ];
    /** @nocollapse */
    ToastDirective.ctorParameters = function () { return [
        { type: ViewContainerRef }
    ]; };
    return ToastDirective;
}());
if (false) {
    /** @type {?} */
    ToastDirective.prototype.viewContainerRef;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/bootstrap-toast.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BootstrapToastComponent = /** @class */ (function () {
    function BootstrapToastComponent(service) {
        this.service = service;
    }
    /**
     * @return {?}
     */
    BootstrapToastComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.service.init(this.toastHost.viewContainerRef, NotificationComponent);
    };
    BootstrapToastComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-bootstrap-toast',
                    template: "\n    <div class=\"notifications\">\n        <ng-template lib-bootstrap-toast-host></ng-template>\n    </div>\n  ",
                    styles: ["\n    .notifications {\n        position: fixed;\n        top: 0px;\n        right: 0px;\n        height: auto;\n    }\n    "]
                }] }
    ];
    /** @nocollapse */
    BootstrapToastComponent.ctorParameters = function () { return [
        { type: BootstrapToastService }
    ]; };
    BootstrapToastComponent.propDecorators = {
        toastHost: [{ type: ViewChild, args: [ToastDirective, { static: true },] }]
    };
    return BootstrapToastComponent;
}());
if (false) {
    /** @type {?} */
    BootstrapToastComponent.prototype.toastHost;
    /**
     * @type {?}
     * @private
     */
    BootstrapToastComponent.prototype.service;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/bootstrap-toast.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BootstrapToastModule = /** @class */ (function () {
    function BootstrapToastModule() {
    }
    BootstrapToastModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        BootstrapToastComponent,
                        ToastDirective,
                        NotificationComponent
                    ],
                    imports: [
                        CommonModule,
                        BrowserAnimationsModule
                    ],
                    entryComponents: [
                        NotificationComponent
                    ],
                    exports: [
                        BootstrapToastComponent
                    ]
                },] }
    ];
    return BootstrapToastModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: bootstrap-toast.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { BootstrapToastComponent, BootstrapToastModule, BootstrapToastService, ToastDirective as ɵa, NotificationComponent as ɵb };
//# sourceMappingURL=bootstrap-toast.js.map
